diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/geo-to-cartesian-test.cc ns-3.42/src/mobility/test/geo-to-cartesian-test.cc
--- ns-3.41/src/mobility/test/geo-to-cartesian-test.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/test/geo-to-cartesian-test.cc	2024-05-29 15:29:47.136073600 -0700
@@ -1800,7 +1800,7 @@
 };
 
 GeoToCartesianTestSuite::GeoToCartesianTestSuite()
-    : TestSuite("geo-to-cartesian", UNIT)
+    : TestSuite("geo-to-cartesian", Type::UNIT)
 {
     NS_LOG_INFO("creating GeoToCartesianTestSuite");
     int i = 0; // iteration number
@@ -1815,13 +1815,13 @@
                                                        altitude,
                                                        GeographicPositions::SPHERE,
                                                        i),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
                 AddTestCase(new CartesianToGeoTestCase(latitude,
                                                        longitude,
                                                        altitude,
                                                        GeographicPositions::SPHERE,
                                                        i),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
                 ++i;
             }
         }
@@ -1838,13 +1838,13 @@
                                                        altitude,
                                                        GeographicPositions::GRS80,
                                                        i),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
                 AddTestCase(new CartesianToGeoTestCase(latitude,
                                                        longitude,
                                                        altitude,
                                                        GeographicPositions::GRS80,
                                                        i),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
                 ++i;
             }
         }
@@ -1861,13 +1861,13 @@
                                                        altitude,
                                                        GeographicPositions::WGS84,
                                                        i),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
                 AddTestCase(new CartesianToGeoTestCase(latitude,
                                                        longitude,
                                                        altitude,
                                                        GeographicPositions::WGS84,
                                                        i),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
                 ++i;
             }
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/mobility-test-suite.cc ns-3.42/src/mobility/test/mobility-test-suite.cc
--- ns-3.41/src/mobility/test/mobility-test-suite.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/test/mobility-test-suite.cc	2024-05-29 15:29:47.136073600 -0700
@@ -484,12 +484,12 @@
 };
 
 MobilityTestSuite::MobilityTestSuite()
-    : TestSuite("mobility", UNIT)
+    : TestSuite("mobility", Type::UNIT)
 {
-    AddTestCase(new WaypointLazyNotifyFalse, TestCase::QUICK);
-    AddTestCase(new WaypointLazyNotifyTrue, TestCase::QUICK);
-    AddTestCase(new WaypointInitialPositionIsWaypoint, TestCase::QUICK);
-    AddTestCase(new WaypointMobilityModelViaHelper, TestCase::QUICK);
+    AddTestCase(new WaypointLazyNotifyFalse, TestCase::Duration::QUICK);
+    AddTestCase(new WaypointLazyNotifyTrue, TestCase::Duration::QUICK);
+    AddTestCase(new WaypointInitialPositionIsWaypoint, TestCase::Duration::QUICK);
+    AddTestCase(new WaypointMobilityModelViaHelper, TestCase::Duration::QUICK);
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/mobility-trace-test-suite.cc ns-3.42/src/mobility/test/mobility-trace-test-suite.cc
--- ns-3.41/src/mobility/test/mobility-trace-test-suite.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/test/mobility-trace-test-suite.cc	2024-05-29 15:29:47.136073600 -0700
@@ -124,9 +124,9 @@
 };
 
 MobilityTraceTestSuite::MobilityTraceTestSuite()
-    : TestSuite("mobility-trace", UNIT)
+    : TestSuite("mobility-trace", Type::UNIT)
 {
-    AddTestCase(new MobilityTraceTestCase, TestCase::QUICK);
+    AddTestCase(new MobilityTraceTestCase, TestCase::Duration::QUICK);
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/ns2-mobility-helper-test-suite.cc ns-3.42/src/mobility/test/ns2-mobility-helper-test-suite.cc
--- ns-3.41/src/mobility/test/ns2-mobility-helper-test-suite.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/test/ns2-mobility-helper-test-suite.cc	2024-05-29 15:29:47.136073600 -0700
@@ -328,7 +328,7 @@
 {
   public:
     Ns2MobilityHelperTestSuite()
-        : TestSuite("mobility-ns2-trace-helper", UNIT)
+        : TestSuite("mobility-ns2-trace-helper", Type::UNIT)
     {
         SetDataDir(NS_TEST_SOURCEDIR);
 
@@ -342,7 +342,7 @@
                     "$node_(0) set Y_ 2.0\n"
                     "$node_(0) set Z_ 3.0\n");
         t->AddReferencePoint("0", 0, Vector(1, 2, 3), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Check parsing comments, empty lines and no EOF at the end of file
         t = new Ns2MobilityHelperTest("comments", Seconds(1));
@@ -353,7 +353,7 @@
                     "$node_(0) set Z_ 3.0 # $node_(0) set Z_ 3.0\n"
                     "#$node_(0) set Z_ 100 #");
         t->AddReferencePoint("0", 0, Vector(1, 2, 3), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Simple setdest. Arguments are interpreted as x, y, speed by default
         t = new Ns2MobilityHelperTest("simple setdest", Seconds(10));
@@ -362,7 +362,7 @@
         t->AddReferencePoint("0", 0, Vector(0, 0, 0), Vector(0, 0, 0));
         t->AddReferencePoint("0", 1, Vector(0, 0, 0), Vector(5, 0, 0));
         t->AddReferencePoint("0", 6, Vector(25, 0, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Several set and setdest. Arguments are interpreted as x, y, speed by default
         t = new Ns2MobilityHelperTest("square setdest", Seconds(6));
@@ -382,7 +382,7 @@
         t->AddReferencePoint("0", 4, Vector(0, 5, 0), Vector(0, 0, 0));
         t->AddReferencePoint("0", 4, Vector(0, 5, 0), Vector(0, -5, 0));
         t->AddReferencePoint("0", 5, Vector(0, 0, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Copy of previous test case but with the initial positions at
         // the end of the trace rather than at the beginning.
@@ -405,7 +405,7 @@
         t->AddReferencePoint("0", 4, Vector(10, 15, 0), Vector(0, 0, 0));
         t->AddReferencePoint("0", 4, Vector(10, 15, 0), Vector(0, -5, 0));
         t->AddReferencePoint("0", 5, Vector(10, 10, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Scheduled set position
         t = new Ns2MobilityHelperTest("scheduled set position", Seconds(2));
@@ -416,7 +416,7 @@
         t->AddReferencePoint("0", 1, Vector(10, 0, 0), Vector(0, 0, 0));
         t->AddReferencePoint("0", 1, Vector(10, 0, 10), Vector(0, 0, 0));
         t->AddReferencePoint("0", 1, Vector(10, 10, 10), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Malformed lines
         t = new Ns2MobilityHelperTest("malformed lines", Seconds(2));
@@ -432,7 +432,7 @@
         t->AddReferencePoint("0", 0, Vector(1, 2, 3), Vector(0, 0, 0));
         t->AddReferencePoint("0", 1, Vector(1, 2, 3), Vector(1, 0, 0));
         t->AddReferencePoint("0", 2, Vector(2, 2, 3), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Non possible values
         t = new Ns2MobilityHelperTest("non possible values", Seconds(2));
@@ -453,7 +453,7 @@
         t->AddReferencePoint("0", 0, Vector(1, 2, 3), Vector(0, 0, 0));
         t->AddReferencePoint("0", 1, Vector(1, 2, 3), Vector(1, 0, 0));
         t->AddReferencePoint("0", 2, Vector(2, 2, 3), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // More than one node
         t = new Ns2MobilityHelperTest("few nodes, combinations of set and setdest", Seconds(10), 3);
@@ -481,7 +481,7 @@
         t->AddReferencePoint("2", 4, Vector(0, 5, 0), Vector(0, 0, 0));
         t->AddReferencePoint("2", 4, Vector(0, 5, 0), Vector(0, -5, 0));
         t->AddReferencePoint("2", 5, Vector(0, 0, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Test for Speed == 0, that acts as stop the node.
         t = new Ns2MobilityHelperTest("setdest with speed cero", Seconds(10));
@@ -492,7 +492,7 @@
         t->AddReferencePoint("0", 1, Vector(0, 0, 0), Vector(5, 0, 0));
         t->AddReferencePoint("0", 6, Vector(25, 0, 0), Vector(0, 0, 0));
         t->AddReferencePoint("0", 7, Vector(25, 0, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Test negative positions
         t = new Ns2MobilityHelperTest("test negative positions", Seconds(10));
@@ -506,7 +506,7 @@
         t->AddReferencePoint("0", 2, Vector(0, 0, 0), Vector(0, 0, 0));
         t->AddReferencePoint("0", 2, Vector(0, 0, 0), Vector(0, -1, 0));
         t->AddReferencePoint("0", 3, Vector(0, -1, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         // Square setdest with values in the form 1.0e+2
         t = new Ns2MobilityHelperTest("Foalt numbers in 1.0e+2 format", Seconds(6));
@@ -526,7 +526,7 @@
         t->AddReferencePoint("0", 4, Vector(0, 100, 0), Vector(0, 0, 0));
         t->AddReferencePoint("0", 4, Vector(0, 100, 0), Vector(0, -100, 0));
         t->AddReferencePoint("0", 5, Vector(0, 0, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
         t = new Ns2MobilityHelperTest("Bug 1219 testcase", Seconds(16));
         t->SetTrace("$node_(0) set X_ 0.0\n"
                     "$node_(0) set Y_ 0.0\n"
@@ -537,13 +537,13 @@
         t->AddReferencePoint("0", 1, Vector(0, 0, 0), Vector(0, 1, 0));
         t->AddReferencePoint("0", 6, Vector(0, 5, 0), Vector(0, -1, 0));
         t->AddReferencePoint("0", 16, Vector(0, -10, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
         t = new Ns2MobilityHelperTest("Bug 1059 testcase", Seconds(16));
         t->SetTrace("$node_(0) set X_ 10.0\r\n"
                     "$node_(0) set Y_ 0.0\r\n");
         //                     id  t  position         velocity
         t->AddReferencePoint("0", 0, Vector(10, 0, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
         t = new Ns2MobilityHelperTest("Bug 1301 testcase", Seconds(16));
         t->SetTrace("$node_(0) set X_ 10.0\n"
                     "$node_(0) set Y_ 0.0\n"
@@ -552,7 +552,7 @@
         // Moving to the current position must change nothing. No NaN
         // speed must be.
         t->AddReferencePoint("0", 0, Vector(10, 0, 0), Vector(0, 0, 0));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
 
         t = new Ns2MobilityHelperTest("Bug 1316 testcase", Seconds(1000));
         t->SetTrace("$node_(0) set X_ 350.00000000000000\n"
@@ -617,6 +617,6 @@
                              920.000,
                              Vector(300.000, 650.000, 0.000),
                              Vector(0.000, 0.000, 0.000));
-        AddTestCase(t, TestCase::QUICK);
+        AddTestCase(t, TestCase::Duration::QUICK);
     }
 } g_ns2TransmobilityHelperTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/rand-cart-around-geo-test.cc ns-3.42/src/mobility/test/rand-cart-around-geo-test.cc
--- ns-3.41/src/mobility/test/rand-cart-around-geo-test.cc	2024-02-09 14:44:08.369793400 -0800
+++ ns-3.42/src/mobility/test/rand-cart-around-geo-test.cc	2024-05-29 15:29:47.136073600 -0700
@@ -183,7 +183,7 @@
 };
 
 RandCartAroundGeoTestSuite::RandCartAroundGeoTestSuite()
-    : TestSuite("rand-cart-around-geo", UNIT)
+    : TestSuite("rand-cart-around-geo", Type::UNIT)
 {
     NS_LOG_INFO("creating RandCartAroundGeoTestSuite");
     Ptr<UniformRandomVariable> uniRand = CreateObject<UniformRandomVariable>();
@@ -201,7 +201,7 @@
                                                           50, // 50 points generated
                                                           maxDistFromOrigin,
                                                           uniRand),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
             }
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/rectangle-closest-border-test.cc ns-3.42/src/mobility/test/rectangle-closest-border-test.cc
--- ns-3.41/src/mobility/test/rectangle-closest-border-test.cc	2024-02-09 14:44:08.369793400 -0800
+++ ns-3.42/src/mobility/test/rectangle-closest-border-test.cc	2024-05-29 15:29:47.136073600 -0700
@@ -93,7 +93,7 @@
  */
 
 RectangleClosestBorderTestSuite::RectangleClosestBorderTestSuite()
-    : TestSuite("rectangle-closest-border", UNIT)
+    : TestSuite("rectangle-closest-border", Type::UNIT)
 {
     // Rectangle in the positive x-plane to check the intersection with.
     Rectangle rectangle = Rectangle(0.0, 10.0, 0.0, 10.0);
@@ -117,47 +117,47 @@
      */
     // Left side (1 and 15)
     AddTestCase(new RectangleClosestBorderTestCase(-5, 5, rectangle, Rectangle::LEFTSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new RectangleClosestBorderTestCase(2, 5, rectangle, Rectangle::LEFTSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     // Right side (5 and 17)
     AddTestCase(new RectangleClosestBorderTestCase(17, 5, rectangle, Rectangle::RIGHTSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new RectangleClosestBorderTestCase(7, 5, rectangle, Rectangle::RIGHTSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     // Bottom side (8 and 14)
     AddTestCase(new RectangleClosestBorderTestCase(5, -7, rectangle, Rectangle::BOTTOMSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new RectangleClosestBorderTestCase(5, 1, rectangle, Rectangle::BOTTOMSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     // Top side (3 and 16)
     AddTestCase(new RectangleClosestBorderTestCase(5, 15, rectangle, Rectangle::TOPSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new RectangleClosestBorderTestCase(5, 7, rectangle, Rectangle::TOPSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     // Left-Bottom corner (9 and 10)
     AddTestCase(new RectangleClosestBorderTestCase(-1, -1, rectangle, Rectangle::BOTTOMLEFTCORNER),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new RectangleClosestBorderTestCase(0, 0, rectangle, Rectangle::BOTTOMLEFTCORNER),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     // Right-Bottom corner (7 and 13)
     AddTestCase(new RectangleClosestBorderTestCase(11, -1, rectangle, Rectangle::BOTTOMRIGHTCORNER),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new RectangleClosestBorderTestCase(9, 1, rectangle, Rectangle::BOTTOMRIGHTCORNER),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     // Left-Top corner (2 and 11)
     AddTestCase(new RectangleClosestBorderTestCase(-1, 11, rectangle, Rectangle::TOPLEFTCORNER),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new RectangleClosestBorderTestCase(1, 9, rectangle, Rectangle::TOPLEFTCORNER),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     // Right-Top corner (4 and 12)
     AddTestCase(new RectangleClosestBorderTestCase(11, 11, rectangle, Rectangle::TOPRIGHTCORNER),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new RectangleClosestBorderTestCase(9, 9, rectangle, Rectangle::TOPRIGHTCORNER),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     // Central position (18)
     AddTestCase(new RectangleClosestBorderTestCase(5, 5, rectangle, Rectangle::TOPSIDE),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc ns-3.42/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc
--- ns-3.41/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc	2024-02-09 14:44:08.369793400 -0800
+++ ns-3.42/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc	2024-05-29 15:29:47.136073600 -0700
@@ -156,8 +156,8 @@
 struct SteadyStateRandomWaypointTestSuite : public TestSuite
 {
     SteadyStateRandomWaypointTestSuite()
-        : TestSuite("steady-state-rwp-mobility-model", UNIT)
+        : TestSuite("steady-state-rwp-mobility-model", Type::UNIT)
     {
-        AddTestCase(new SteadyStateRandomWaypointTest, TestCase::QUICK);
+        AddTestCase(new SteadyStateRandomWaypointTest, TestCase::Duration::QUICK);
     }
 } g_steadyStateRandomWaypointTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/waypoint-mobility-model-test.cc ns-3.42/src/mobility/test/waypoint-mobility-model-test.cc
--- ns-3.41/src/mobility/test/waypoint-mobility-model-test.cc	2024-02-09 14:44:08.369793400 -0800
+++ ns-3.42/src/mobility/test/waypoint-mobility-model-test.cc	2024-05-29 15:29:47.136073600 -0700
@@ -259,10 +259,10 @@
 static struct WaypointMobilityModelTestSuite : public TestSuite
 {
     WaypointMobilityModelTestSuite()
-        : TestSuite("waypoint-mobility-model", UNIT)
+        : TestSuite("waypoint-mobility-model", Type::UNIT)
     {
-        AddTestCase(new WaypointMobilityModelNotifyTest(true), TestCase::QUICK);
-        AddTestCase(new WaypointMobilityModelNotifyTest(false), TestCase::QUICK);
-        AddTestCase(new WaypointMobilityModelAddWaypointTest(), TestCase::QUICK);
+        AddTestCase(new WaypointMobilityModelNotifyTest(true), TestCase::Duration::QUICK);
+        AddTestCase(new WaypointMobilityModelNotifyTest(false), TestCase::Duration::QUICK);
+        AddTestCase(new WaypointMobilityModelAddWaypointTest(), TestCase::Duration::QUICK);
     }
 } g_waypointMobilityModelTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mpi/test/mpi-test-suite.cc ns-3.42/src/mpi/test/mpi-test-suite.cc
--- ns-3.41/src/mpi/test/mpi-test-suite.cc	2024-02-09 14:44:08.369793400 -0800
+++ ns-3.42/src/mpi/test/mpi-test-suite.cc	2024-05-29 15:29:47.140073500 -0700
@@ -116,9 +116,9 @@
                  const std::string dataDir,
                  const int ranks,
                  const std::string args = "",
-                 const TestDuration duration = QUICK,
+                 const Duration duration = Duration::QUICK,
                  const bool shouldNotErr = true)
-        : TestSuite(name, EXAMPLE)
+        : TestSuite(name, Type::EXAMPLE)
     {
         AddTestCase(new MpiTestCase(name, program, dataDir, ranks, args, shouldNotErr), duration);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/netanim/examples/wireless-animation.cc ns-3.42/src/netanim/examples/wireless-animation.cc
--- ns-3.41/src/netanim/examples/wireless-animation.cc	2024-02-09 14:44:08.397793500 -0800
+++ ns-3.42/src/netanim/examples/wireless-animation.cc	2024-05-29 15:29:47.144073700 -0700
@@ -30,6 +30,7 @@
 #include "ns3/yans-wifi-helper.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("WirelessAnimationExample");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/netanim/model/animation-interface.cc ns-3.42/src/netanim/model/animation-interface.cc
--- ns-3.41/src/netanim/model/animation-interface.cc	2024-02-09 14:44:08.397793500 -0800
+++ ns-3.42/src/netanim/model/animation-interface.cc	2024-05-29 15:29:47.144073700 -0700
@@ -680,7 +680,7 @@
 
     NS_LOG_INFO("Remaining energy on one of sources on node " << nodeId << ": " << currentEnergy);
 
-    const Ptr<EnergySource> energySource = node->GetObject<EnergySource>();
+    const Ptr<energy::EnergySource> energySource = node->GetObject<energy::EnergySource>();
 
     NS_ASSERT(energySource);
     // Don't call GetEnergyFraction () because of recursion
@@ -1008,14 +1008,14 @@
 
     Ptr<NetDevice> ndev = GetNetDeviceFromContext(context);
     NS_ASSERT(ndev);
-    Ptr<LrWpanNetDevice> netDevice = DynamicCast<LrWpanNetDevice>(ndev);
+    Ptr<lrwpan::LrWpanNetDevice> netDevice = DynamicCast<lrwpan::LrWpanNetDevice>(ndev);
 
     Ptr<Node> n = ndev->GetNode();
     NS_ASSERT(n);
 
     UpdatePosition(n);
 
-    LrWpanMacHeader hdr;
+    lrwpan::LrWpanMacHeader hdr;
     if (!p->PeekHeader(hdr))
     {
         NS_LOG_WARN("LrWpanMacHeader not present");
@@ -2063,7 +2063,7 @@
     for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
-        if (NodeList::GetNode(n->GetId())->GetObject<EnergySource>())
+        if (NodeList::GetNode(n->GetId())->GetObject<energy::EnergySource>())
         {
             UpdateNodeCounter(m_remainingEnergyCounterId, n->GetId(), 1);
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/netanim/test/netanim-test.cc ns-3.42/src/netanim/test/netanim-test.cc
--- ns-3.41/src/netanim/test/netanim-test.cc	2024-02-09 14:44:08.397793500 -0800
+++ ns-3.42/src/netanim/test/netanim-test.cc	2024-05-29 15:29:47.144073700 -0700
@@ -32,6 +32,7 @@
 #include <iostream>
 
 using namespace ns3;
+using namespace ns3::energy;
 
 /**
  * \ingroup netanim
@@ -248,9 +249,9 @@
 {
   public:
     AnimationInterfaceTestSuite()
-        : TestSuite("animation-interface", UNIT)
+        : TestSuite("animation-interface", Type::UNIT)
     {
-        AddTestCase(new AnimationInterfaceTestCase(), TestCase::QUICK);
-        AddTestCase(new AnimationRemainingEnergyTestCase(), TestCase::QUICK);
+        AddTestCase(new AnimationInterfaceTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new AnimationRemainingEnergyTestCase(), TestCase::Duration::QUICK);
     }
 } g_animationInterfaceTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/CMakeLists.txt ns-3.42/src/network/CMakeLists.txt
--- ns-3.41/src/network/CMakeLists.txt	2024-02-09 14:44:08.397793500 -0800
+++ ns-3.42/src/network/CMakeLists.txt	2024-05-29 15:29:47.144073700 -0700
@@ -1,5 +1,6 @@
 set(source_files
     helper/application-container.cc
+    helper/application-helper.cc
     helper/delay-jitter-estimation.cc
     helper/net-device-container.cc
     helper/node-container.cc
@@ -73,6 +74,7 @@
 
 set(header_files
     helper/application-container.h
+    helper/application-helper.h
     helper/delay-jitter-estimation.h
     helper/net-device-container.h
     helper/node-container.h
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/helper/application-helper.cc ns-3.42/src/network/helper/application-helper.cc
--- ns-3.41/src/network/helper/application-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/network/helper/application-helper.cc	2024-05-29 15:29:47.148073700 -0700
@@ -0,0 +1,126 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "application-helper.h"
+
+#include <ns3/data-rate.h>
+#include <ns3/names.h>
+#include <ns3/string.h>
+
+namespace ns3
+{
+
+ApplicationHelper::ApplicationHelper(TypeId typeId)
+{
+    SetTypeId(typeId);
+}
+
+ApplicationHelper::ApplicationHelper(const std::string& typeId)
+{
+    SetTypeId(typeId);
+}
+
+void
+ApplicationHelper::SetTypeId(TypeId typeId)
+{
+    m_factory.SetTypeId(typeId);
+}
+
+void
+ApplicationHelper::SetTypeId(const std::string& typeId)
+{
+    m_factory.SetTypeId(typeId);
+}
+
+void
+ApplicationHelper::SetAttribute(const std::string& name, const AttributeValue& value)
+{
+    m_factory.Set(name, value);
+}
+
+ApplicationContainer
+ApplicationHelper::Install(Ptr<Node> node)
+{
+    return ApplicationContainer(DoInstall(node));
+}
+
+ApplicationContainer
+ApplicationHelper::Install(const std::string& nodeName)
+{
+    auto node = Names::Find<Node>(nodeName);
+    NS_ABORT_MSG_IF(!node, "Node " << nodeName << " does not exist");
+    return ApplicationContainer(DoInstall(node));
+}
+
+ApplicationContainer
+ApplicationHelper::Install(NodeContainer c)
+{
+    ApplicationContainer apps;
+    for (auto i = c.Begin(); i != c.End(); ++i)
+    {
+        apps.Add(DoInstall(*i));
+    }
+    return apps;
+}
+
+Ptr<Application>
+ApplicationHelper::DoInstall(Ptr<Node> node)
+{
+    NS_ABORT_MSG_IF(!node, "Node does not exist");
+    auto app = m_factory.Create<Application>();
+    node->AddApplication(app);
+    return app;
+}
+
+int64_t
+ApplicationHelper::AssignStreams(NodeContainer c, int64_t stream)
+{
+    NS_ABORT_MSG_IF(!m_factory.IsTypeIdSet(), "Type ID not set");
+    auto currentStream = stream;
+    for (auto i = c.Begin(); i != c.End(); ++i)
+    {
+        auto node = (*i);
+        for (uint32_t j = 0; j < node->GetNApplications(); ++j)
+        {
+            if (auto app = node->GetApplication(j);
+                app->GetInstanceTypeId() == m_factory.GetTypeId())
+            {
+                currentStream += app->AssignStreams(currentStream);
+            }
+        }
+    }
+    return (currentStream - stream);
+}
+
+int64_t
+ApplicationHelper::AssignStreamsToAllApps(NodeContainer c, int64_t stream)
+{
+    auto currentStream = stream;
+    for (auto i = c.Begin(); i != c.End(); ++i)
+    {
+        auto node = (*i);
+        for (uint32_t j = 0; j < node->GetNApplications(); ++j)
+        {
+            currentStream += node->GetApplication(j)->AssignStreams(currentStream);
+        }
+    }
+    return (currentStream - stream);
+}
+
+} // namespace ns3
